$(document).ready(function()
{
    /* Action */
    $(document).on('change', '#actionTable #type', function()
    {
        $('#batchMode').parents('tr').toggle($(this).val() == 'batch');
        $('#position, #show').parents('tr').toggle($(this).val() == 'single');
        $('#open option[value=modal]').toggle($(this).val() == 'single');
        if($(this).val() == 'batch' && $('#open').val() == 'modal')
        {
            $('#open').val('normal');
        }
    });

    $('a.mode-toggle').click(function()
    {
        $('a.mode-toggle').removeClass('active');
        $(this).addClass('active');
        $('#mainContent').find('#cardMode, #listMode').hide();
        $('#' + $(this).data('mode') + 'Mode').show();
        $.cookie('actionViewType', $(this).data('mode'), {path: "/"});
    })

    var type = $.cookie('actionViewType');
    if(typeof(type) == 'undefined' || type == '') type = 'list';
    $('.menu-actions a[data-mode=' + type +']').click();

    var dateOptions =
    {
        language:  config.clientLang,
        weekStart: 1,
        todayBtn:  1,
        autoclose: 1,
        todayHighlight: 1,
        startView: 2,
        minView: 2,
        forceParse: 0,
        format: 'yyyy-mm-dd'
    };
    var datetimeOptions =
    {
        language:  config.clientLang,
        weekStart: 1,
        todayBtn:  1,
        autoclose: 1,
        todayHighlight: 1,
        startView: 2,
        forceParse: 0,
        showMeridian: 1,
        format: 'yyyy-mm-dd hh:ii'
    };

    /* Verification */
    $(document).on('change', '#verificationTable [name^=paramType], #verificationTable [name*=\\[field\\]], #verificationTable [name*=\\[paramType\\]]', function()
    {
        var $tr       = $(this).closest('tr');
        var paramType = $tr.find('[name*=paramType]').val();
        if(paramType != 'custom')
        {
            var name = 'param[]';
            if($tr.hasClass('dataTR'))  name = 'conditions[param][]';
            if($tr.hasClass('fieldTR')) name = 'fields[param][]';
            if($tr.hasClass('whereTR')) name = 'wheres[param][]';

            if($tr.find('span.param .chosen').length == 0) $tr.find('span.param .chosen').html("<select name='" + name + "' id='param' class='form-control chosen'></select>");
            $tr.find('span.param .chosen').chosen(window.chosenDefaultOptions);
        }

        if(paramType == 'today' || paramType == 'now' || paramType == 'actor' || paramType == 'deptManager')
        {
            $tr.find('input#param').attr('disabled', 'disabled').val('').show();
            $tr.find('select#param').removeAttr('disabled');
            $tr.find('#param_chosen').hide();
        }
        else if(paramType == 'custom')
        {
            $tr.find('input#param').attr('disabled', 'disabled').hide();
            var field = $tr.find('[name*=\\[field\\]]').val();
            var name  = $tr.find('input#param').attr('name');
            var id    = $tr.find('input#param').attr('id');

            name = window.btoa(encodeURI(name));
            var link = createLink('workflowfield', 'ajaxGetFieldControl', 'module=' + module + '&field=' + field + '&value=&elementName=' + name + '&elementID=' + id);

            $.get(link, function(data)
            {
                paramValue = $tr.find('span.param .chosen').val();
                $tr.find('span.param').html(data);
                $tr.find('span.param .chosen').val(paramValue).chosen(window.chosenDefaultOptions);

                $tr.find('span.param .form-date').datetimepicker(dateOptions);

                $tr.find('span.param .form-datetime').datetimepicker(datetimeOptions);
            });
        }
        else if(paramType == 'form')
        {
            var value = $tr.find('select#param').val();
            $tr.find('input#param').attr('disabled', 'disabled').hide();
            $tr.find('#param_chosen .chosen-single span').html('');
            $tr.find('#param_chosen').show();
            $tr.find('#param_chosen .chosen-single').focus();
            $tr.find('select#param').removeAttr('disabled').empty().append($('#formFieldsDIV').html());
            $tr.find('select#param').val(value).trigger('chosen:updated');
        }
        else if(paramType == 'record')
        {
            $tr.find('input#param').attr('disabled', 'disabled').hide();
            $tr.find('#param_chosen .chosen-single span').html('');
            $tr.find('#param_chosen').show();
            $tr.find('#param_chosen .chosen-single').focus();
            var value = $tr.find('select#param').val();
            $tr.find('select#param').removeAttr('disabled').empty().append($('#recordFieldsDIV').html());
            $tr.find('select#param').val(value).trigger('chosen:updated');
        }
        else
        {
            $tr.find('input#param').attr('disabled', 'disabled').hide();
            var value = $tr.find('select#param').val();

            value = window.btoa(encodeURI(value));

            var link  = createLink('workflowfield', 'ajaxGetParamOptions', 'paramType=' + $(this).val() + '&param=' + value);
            $tr.find('select#param').removeAttr('disabled').load(link, function()
            {
                $tr.find('select#param').trigger('chosen:updated');
            });
            $tr.find('#param_chosen .chosen-single span').html('');
            $tr.find('#param_chosen').show();
            $tr.find('#param_chosen .chosen-single').focus();
        }
    });

    $(document).on('click', '#verificationTable .addVerification, #verificationTable .addVar', function()
    {
        var $tr = $(this).parents('tr');
        if($(this).hasClass('addVar'))
        {
            $tr.after(varRow);
        }
        else if($(this).hasClass('addVerification'))
        {
            $tr.after(verificationRow);
        }
        $tr.next().find('.chosen').chosen(window.chosenDefaultOptions);
        $tr.next().find('#param_chosen').hide();
    });

    $(document).on('click', '#verificationTable .delVerification, #verificationTable .delVar', function()
    {
        if($(this).hasClass('delVar'))
        {
            $('#sql').val($('#sql').val().replace("'$" + $(this).parents('tr').find('#varName').val() + "'", ''));
            if($('.delVar').size() == 1) 
            { 
                $(this).parents('tr').find('input,select').val('').find('.chosen').trigger('chosen:updated');
                $(this).parents('tr').find('.chosen-single span').html('');
                return;
            }
        }

        $(this).parents('tr').remove();
    });

    $(document).on('change', '#verificationTable [name*=varName]', function()
    {
        if($(this).val() != '') $('#sql').val($('#sql').val() + "'$" + $(this).val() + "'");
    });
});
