<?php
/**
 * The browse view file of workflowlinkage module of ZDOO.
 *
 * @copyright   Copyright 2009-2016 青岛易软天创网络科技有限公司(QingDao Nature Easy Soft Network Technology Co,LTD, www.cnezsoft.com)
 * @license     商业软件，非开源软件
 * @author      Gang Liu <liugang@cnezsoft.com>
 * @package     workflowlinkage
 * @version     $Id$
 * @link        http://www.zdoo.com
 */
?>
<?php include '../../common/view/header.html.php';?>
<?php js::set('action', $action->id);?>
<div id='menuActions'>
  <?php extCommonModel::printLink('workflowlinkage', 'create', "action=$action->id", "<i class='icon-plus'> </i>" . $lang->workflowlinkage->create, "class='btn btn-primary' data-toggle='modal'");?>
</div>
<div class='main-row'>
  <div class='side-col'>
    <div class='panel panel-block'>
      <div class='panel-heading'>
        <strong><?php echo $lang->workflowaction->common;?></strong>
      </div>
      <div class='panel-body'>
        <ul class='tree treeview'>
          <?php foreach($actions as $currentAction):?>
          <?php if(!$this->workflowaction->isClickable($currentAction, 'browselinkage')) continue;?>
          <?php echo '<li>' . baseHTML::a(inlink('browse', "action=$currentAction->id"), $currentAction->name) . '</li>';?>
          <?php endforeach;?>
        </ul>
        <div class='text-right'><?php extCommonModel::printLink('workflowaction', 'browse', "module=$flow->module", $lang->workflowaction->browse, "class='btn btn-primary'");?></div>
      </div>
    </div>
  </div>
  <div class='main-col'>
    <div class='panel'>
    <table class='table table-fixed' id='linkageTable'>
      <thead>
        <tr class='text-center'>
          <th><?php echo $lang->workflowlinkage->source;?></th>
          <th><?php echo $lang->workflowlinkage->target;?></th>
          <th class='w-80px'><?php echo $lang->actions;?></th>
        </tr>
      </thead>
      <tbody>
        <?php foreach($action->linkages as $key => $linkage):?>
        <?php $sources  = zget($linkage, 'sources', array());?>
        <?php $targets  = zget($linkage, 'targets', array());?>
        <tr class='text-left'>
          <td>
            <?php
            foreach($sources as $source)
            {
                if(!isset($fields[$source->field])) continue;
            
                $field = $fields[$source->field];
                echo $field->name . zget($config->workflowlinkage->operatorList, $source->operator);
                if($field->control == 'multi-select' or $field->control == 'checkbox')
                {
                    $values = explode(',', $source->value);
                    foreach($values as $value) echo zget($field->options, $value) . ' ' ;
                }
                else
                {
                    echo zget($field->options, $source->value);
                }
            }
            ?>
          </td>
          <td>
            <?php
            foreach($targets as $target)
            {
                if(!isset($fields[$target->field])) continue;

                $field = $fields[$target->field];
                echo $field->name . "[{$lang->workflowlinkage->statusList[$target->status]}]&nbsp;&nbsp;&nbsp;&nbsp;";
            }
            ?>
          </td>
          <td class='text-center'>
            <?php extCommonModel::printLink('workflowlinkage', 'edit',   "action=$action->id&key=$key", $lang->edit, "data-toggle='modal'");?>
            <?php extCommonModel::printLink('workflowlinkage', 'delete', "action=$action->id&key=$key", $lang->delete, "class='deleter'");?>
          </td>
        </tr>
        <?php endforeach;?>
      </tbody>
    </table>
    </div>
    <div class='main-actions'>
      <div class='btn-toolbar'>
        <?php extCommonModel::printLink('workflowaction', 'browse', "module=$flow->module", $lang->goback, "class='btn btn-back'");?>
      </div>
    </div>
  </div>
</div>
<?php include '../../common/view/footer.html.php';?>
